/************************************************************************/
/*                                                                      */
/*                      RC5 Remote Receiver                             */
/*                                                                      */
/*              Author: xxxxxxxxxxxxxxxxx                               */
/*                                                                      */
/*                                                                      */
/************************************************************************/
#include "main.h"





void init(void)
{
TCCR0B = (1<<CS01);  //Prescaler 8
TIMSK0= (1<<TOIE0);
TCNT0 = 129;


DDRB= (1<<PB1)|(1<<PB2);
PORTD=(1<<PD5);
}



int main( void )

{
  //Variablen
  unsigned int i;
  unsigned int ToggleBit;
  unsigned int DeviceAdress;
  unsigned int KeyCode;
 

  //Initialisierungen
  init();
  
  sei();
  
  //Hauptschleife
  while(1)
   {				
    cli();
    i = rc5_data;			         //2 Bytes aus Interrupt lesen
    rc5_data = 0;
    sei();


    if( i )					 //wenn Daten Empfangen
    {					 
     			        
    ToggleBit= i >>11 & 1;			 // Toggle Bit
     
    DeviceAdress= i >> 6 & 0x1F;	//Gerte Adresse
      
    KeyCode= (i & 0x3F) | (~i >> 7 & 0x40); 	 // Tastencode



    if (DeviceAdress==16)			 //Gerteadresse 16
	{
	if(KeyCode==16)				 //KeyCode abfragen
	{
	PORTB ^= (1<<PB1); //PB1 blinken lassen
	}
    }

     
    }//end Daten RC5 Empfangen

   }//end Hauptschleife

 }//end main
